Attribute VB_Name = "modTest"
Option Explicit

Public m_Stop As Boolean

Public m_Ports() As Port

' Return values from OpenPortRange
'  If all ports open, returns OPR_SUCCESS
'  If one port fails to open, returns the failed port number
'  If more than one port fails to open, returns OPR_MULTI_FAIL
'  Failed ports have hCom = INVALID_HANDLE_VALUE
Public Const OPR_SUCCESS As Integer = 0
Public Const OPR_MULTI_FAIL As Integer = -1

' Return values from ClosePortRange
'  If all ports close, returns CPR_SUCCESS
'  If one port fails to close, returns the failed port number
'  If more than one port fails to close, returns CPR_MULTI_FAIL
'  Closed ports have hCom = INVALID_HANDLE_VALUE,
'    failed ports have hCom unchanged
Public Const CPR_SUCCESS As Integer = 0
Public Const CPR_MULTI_FAIL As Integer = -1

Public Sub DataTransferTest(ByVal LowPortNum As Integer, ByVal HighPortNum As Integer, ByVal Rate As Long)

    Dim DataOut(0 To 127) As Byte
    Dim BytesWritten As Long
    Dim DataIn(0 To 127) As Byte
    Dim BytesRead As Long
    Dim Ret As Long
    Dim tDCB As DCB
    Dim CurrIdx As Integer
    Dim i As Integer
    
    For i = LowPortNum To HighPortNum
        
        If (m_Stop) Then
            Exit Sub
        End If
        
        CurrIdx = i - LowPortNum
        With m_Ports(CurrIdx)
        
            For Ret = 0 To 127
                DataOut(Ret) = Int((255 * Rnd) + 1)
            Next Ret

            Ret = WriteFile(.hCom, DataOut(0), 128, BytesWritten, Null)
            DoEvents
            If (Ret = 0) Then
                .NumSentFail = .NumSentFail + 1
            Else
                .NumSent = .NumSent + 1

                Ret = ReadFile(.hCom, DataIn(0), 128, BytesRead, Null)
                DoEvents
                If (Ret = 0 Or BytesRead <> 128) Then
                    .NumReceivedFail = .NumReceivedFail + 1
                Else
                    .NumReceived = .NumReceived + 1
                    
                    For Ret = 0 To 127
                        If (DataOut(Ret) <> DataIn(Ret)) Then
                            .NumCompFailed = .NumCompFailed + 1
                            Exit For
                        End If
                    Next Ret
                End If
            End If
        End With
    If (Rate <= 38400) Then
        UpdateResults LowPortNum, HighPortNum
    End If
    Next i
    
End Sub

Public Function OpenPortRange(LowPortNum As Integer, HighPortNum As Integer, Rate As Long) As Integer

    Dim i As Integer
    Dim ReturnVal As Integer
    Dim tDCB As DCB
    Dim Ret As Long
    Dim timeouts As COMMTIMEOUTS
    
    ReturnVal = OPR_SUCCESS
        
    For i = LowPortNum To HighPortNum
        ReDim Preserve m_Ports(0 To i - LowPortNum) As Port
        
        m_Ports(i - LowPortNum).hCom = INVALID_HANDLE_VALUE
        m_Ports(i - LowPortNum).hCom = CreateFile("\\.\COM" & i, GENERIC_READ Or GENERIC_WRITE, 0, Null, OPEN_EXISTING, 0, 0)
    
        If (m_Ports(i - LowPortNum).hCom <> INVALID_HANDLE_VALUE) Then
            m_Ports(i - LowPortNum).PortNum = i
            
            Ret = GetCommState(m_Ports(i - LowPortNum).hCom, tDCB)
            tDCB.BaudRate = Rate
            ' Example of using bitfield functions
            'DebugPrintInBinary tDCB.fBitFields
            'Ret = BitFieldGet(tDCB.fBitFields, F_PARITY)
            'If (Ret = F_PARITY) Then  'Parity bit on
            '    BitFieldSetOff tDCB.fBitFields, F_PARITY  'So turn it of
            'Else  'Parity off
            '    BitFieldSetOn tDCB.fBitFields, F_PARITY  'So turn it on
            'End If
            'DebugPrintInBinary tDCB.fBitFields
            'Ret = BitFieldGet(tDCB.fBitFields, F_PARITY)
            
            'DebugPrintInBinary tDCB.fBitFields
            'Ret = BitFieldGet(tDCB.fBitFields, F_RTS_CONTROL)
            'BitFieldSetRTS tDCB.fBitFields, RTS_CONTROL_ENABLE
            'BitFieldSetDTR tDCB.fBitFields, DTR_CONTROL_ENABLE
            'DebugPrintInBinary tDCB.fBitFields
            'Ret = BitFieldGet(tDCB.fBitFields, F_RTS_CONTROL)
            
            Ret = SetCommState(m_Ports(i - LowPortNum).hCom, tDCB)

            With timeouts
                .ReadIntervalTimeout = 0
                .ReadTotalTimeoutConstant = 50
                .ReadTotalTimeoutMultiplier = 1
            End With
            SetCommTimeouts m_Ports(i - LowPortNum).hCom, timeouts

        Else
            m_Ports(i - LowPortNum).PortNum = -1
            If (ReturnVal = OPR_SUCCESS) Then
                ReturnVal = i
            Else
                ReturnVal = OPR_MULTI_FAIL
            End If
        End If
    Next i

    OpenPortRange = ReturnVal
End Function

Public Function ClosePortRange(ByVal LowPortNum As Integer, ByVal HighPortNum As Integer) As Integer

    Dim i As Integer
    Dim Ret As Integer
    Dim ReturnVal As Integer
    
    ReturnVal = CPR_SUCCESS
    
    For i = LowPortNum To HighPortNum
        If (m_Ports(i - LowPortNum).hCom <> INVALID_HANDLE_VALUE) Then
            Ret = CloseHandle(m_Ports(i - LowPortNum).hCom)
            If (Ret = 0) Then
                If (ReturnVal = CPR_SUCCESS) Then
                    ReturnVal = i
                Else
                    ReturnVal = CPR_MULTI_FAIL
                End If
            Else
                With m_Ports(i - LowPortNum)
                    .hCom = INVALID_HANDLE_VALUE
                    .PortNum = 0
                    .NumSent = 0
                    .NumSentFail = 0
                    .NumReceived = 0
                    .NumReceivedFail = 0
                    .NumCompFailed = 0
                End With
            End If
        End If
    Next i

    ClosePortRange = ReturnVal
End Function

Public Sub UpdateResults(ByVal LowPortNum As Integer, ByVal HighPortNum As Integer)
    
    Dim i As Integer
    
    For i = LowPortNum To HighPortNum
        With frmMain.lvResults.ListItems(i - LowPortNum + 1)
            .SubItems(1) = m_Ports(i - LowPortNum).NumSent
            .SubItems(2) = m_Ports(i - LowPortNum).NumSentFail
            .SubItems(3) = m_Ports(i - LowPortNum).NumReceived
            .SubItems(4) = m_Ports(i - LowPortNum).NumReceivedFail
            .SubItems(5) = m_Ports(i - LowPortNum).NumCompFailed
        End With
    Next i
    
End Sub

Public Sub CreateResultLines(ByVal LowPortNum As Integer, ByVal HighPortNum As Integer)

    Dim i As Integer
    
    For i = LowPortNum To HighPortNum
        frmMain.lvResults.ListItems.Add , , m_Ports(i - LowPortNum).PortNum
    Next i
End Sub

Public Sub ClearResultLines()
    frmMain.lvResults.ListItems.Clear
End Sub
